#!/usr/bin/env python2
##################################################
# GNU Radio Python Flow Graph
# Title: Zmq Stream
# Generated: Thu Aug  6 19:48:48 2015
##################################################

from gnuradio import analog
from gnuradio import blocks
from gnuradio import eng_notation
from gnuradio import gr
from gnuradio import zeromq
from gnuradio.eng_option import eng_option
from gnuradio.filter import firdes
from optparse import OptionParser


class zmq_stream(gr.top_block):

    def __init__(self):
        gr.top_block.__init__(self, "Zmq Stream")

        ##################################################
        # Variables
        ##################################################
        self.samp_rate = samp_rate = 100e3

        ##################################################
        # Blocks
        ##################################################
        self.zeromq_sub_source_0 = zeromq.sub_source(gr.sizeof_float, 1, "tcp://127.0.0.1:5555", 100, True)
        self.zeromq_req_source_0 = zeromq.req_source(gr.sizeof_float, 1, "tcp://127.0.0.1:5557", 100, True)
        self.zeromq_rep_sink_0 = zeromq.rep_sink(gr.sizeof_float, 1, "tcp://127.0.0.1:5557", 100, True)
        self.zeromq_push_sink_0 = zeromq.push_sink(gr.sizeof_float, 1, "tcp://127.0.0.1:5556", 100, True)
        self.zeromq_pull_source_0 = zeromq.pull_source(gr.sizeof_float, 1, "tcp://127.0.0.1:5556", 100, True)
        self.zeromq_pub_sink_0 = zeromq.pub_sink(gr.sizeof_float, 1, "tcp://127.0.0.1:5555", 100, True)
        self.blocks_throttle_0 = blocks.throttle(gr.sizeof_float*1, samp_rate,True)
        self.blocks_stream_to_tagged_stream_0 = blocks.stream_to_tagged_stream(gr.sizeof_float, 1, 1000, "packet_len")
        self.blocks_null_sink_0 = blocks.null_sink(gr.sizeof_float*1)
        self.analog_sig_source_x_0 = analog.sig_source_f(samp_rate, analog.GR_COS_WAVE, 1000, 1, 0)

        ##################################################
        # Connections
        ##################################################
        self.connect((self.analog_sig_source_x_0, 0), (self.blocks_throttle_0, 0))    
        self.connect((self.blocks_stream_to_tagged_stream_0, 0), (self.zeromq_pub_sink_0, 0))    
        self.connect((self.blocks_stream_to_tagged_stream_0, 0), (self.zeromq_push_sink_0, 0))    
        self.connect((self.blocks_stream_to_tagged_stream_0, 0), (self.zeromq_rep_sink_0, 0))    
        self.connect((self.blocks_throttle_0, 0), (self.blocks_stream_to_tagged_stream_0, 0))    
        self.connect((self.zeromq_pull_source_0, 0), (self.blocks_null_sink_0, 1))    
        self.connect((self.zeromq_req_source_0, 0), (self.blocks_null_sink_0, 2))    
        self.connect((self.zeromq_sub_source_0, 0), (self.blocks_null_sink_0, 0))    


    def get_samp_rate(self):
        return self.samp_rate

    def set_samp_rate(self, samp_rate):
        self.samp_rate = samp_rate
        self.analog_sig_source_x_0.set_sampling_freq(self.samp_rate)
        self.blocks_throttle_0.set_sample_rate(self.samp_rate)


if __name__ == '__main__':
    parser = OptionParser(option_class=eng_option, usage="%prog: [options]")
    (options, args) = parser.parse_args()
    tb = zmq_stream()
    tb.start()
    try:
        raw_input('Press Enter to quit: ')
    except EOFError:
        pass
    tb.stop()
    tb.wait()
